﻿/*
Название: LinkLayersVisibility.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5
Версия: 1.0
Назначение: Изменение видимости слоев в изображениях, имеющих ссылку на общий файл.
Может обрабатывать несколько выделенных изображений или изображения 
в выбранном диапазоне (активный разворот или документ)
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: LinkLayersVisibility.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5
Version: 1.0
Function: Changes layers visibility of linked images which have common source file. 
Can process a few selected instances or ones in chosen range (active spread or document)
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
// описание глобальных переменных
var the_title = "LinkLayersVisibility";
var the_version = "1.0";
var AD; // активный док-т
var AL; // активный слой
var AP; // активная страница
var AS;// активный разворот
var the_sel; // выделение в акт. док-те
//
var N_sel = 0; // кол-во объектов в выделении
var N_doc = 0; //  кол-во док-тов в InDesign
var dlg; // основной диалог
//
var ALL_GRAF = new Array(); // массив всех изображений
var ALL_GRAF_PAR = new Array(); // массив родителей изображений (фреймов)
var ALL_GRAF_INDEX = new Array(); // массив индексов в родителях
var N_G = 0; // число изображений
var LINKS_OK = true;
var LINKS_EMB = false;
var DIF = false;
var N_EMBED = 0;
var N_L  = 0;
var LAYER_VIS_DIAL =  new Array(); //массив видимостей для диалога
var LAYER_NAME = new Array(); // массив имен слоев
var DIF_LAY = false;
var DIAL_STAT = new Array();
var DIAL_STAT_DISPLAY = new Array();
var N_OK = 0;
var N_ER = 0;
var N_EMB_SKIP = 0;
var IMG_TYPE = "";
var ORIG_VIS = new Array();
var WHAT_PROC;
var FP = "";
var LINK_FN = "";
var LL = new Array();
var LV = new Array();
var LAYER_WAS_OPEN = false;
var WFS = false;
var SOME_INV = false;
// 
//
// вызов главной подпрограммы
main();
// окончание выполнения скрипта :)))
//
// блок описания подпрограмм
//
// подпрограмма поиска графики
function FIND_GRAF ( the_obj )
{
	function OK_LAYERS( g )
	{
		try
		{
			var L = g.graphicLayerOptions.graphicLayers.length;
			if( L > 0 ) return true;
		} catch ( error ) {};
		SOME_INV = true;
		return false;
	};// end OK_LAYERS
	var the_name = the_obj.constructor.name;
	// проверка ЕПС
	if( the_name == "EPS" ) SOME_INV = true;
	try { if( the_obj.epss.length > 0 ) SOME_INV = true } catch (error ) {};
	// проверка ПИКТ
	if( the_name == "PICT" ) SOME_INV = true;
	try { if( the_obj.picts.length > 0 ) SOME_INV = true } catch (error ) {};
	// проверка ВМФ
	if( the_name == "WMF" ) SOME_INV = true;
	try { if( the_obj.wmfs.length > 0 ) SOME_INV = true } catch (error ) {};
	// проверка вставленное изображение
	if( the_name == "Image" )
	{
		try 
		{
			if( the_obj.itemLink == null ) SOME_INV = true;
		} catch (error ) {};// try-catch
	};// if
	// если это что-то из подходящих изображений
	if( the_name == "PDF" || the_name == "Image" || the_name == "ImportedPage" )
	{
		if( OK_LAYERS( the_obj ) ) ALL_GRAF.push( the_obj );
	};// if
	var N_IM = 0;
	var IMS;
	var N_PDF = 0;
	var PDFS;
	var IMPS;
	var N_IMP = 0;
	try{ IMS = the_obj.images; N_IM = IMS.length } catch ( error ) {};
	try{ PDFS = the_obj.pdfs; N_PDF = PDFS.length } catch ( error ) {};
	try{ IMPS = the_obj.importedPages; N_IMP = IMPS.length } catch ( error ) {};
	for( var i=0; i<N_IM; i++ )   if( OK_LAYERS( IMS[i] ) ) ALL_GRAF.push( IMS[i] );
	for( var i=0; i<N_PDF; i++ ) if( OK_LAYERS( PDFS[i] ) ) ALL_GRAF.push( PDFS[i] );
	for( var i=0; i<N_IMP; i++ ) if( OK_LAYERS( IMPS[i] ) ) ALL_GRAF.push( IMPS[i] );
	try
	{
		for( var i=0; i < the_obj.pageItems.length; i++ ) FIND_GRAF ( the_obj.pageItems[i] );
	} catch ( error ) {};
	return;
};// end FIND_GRAF
//
// проверка все ли изображения от одного линка
function SAME_LINK()
{
	var RET = true;
	var N_L_i;
	// цикл по всем изображениям
	for( var i=0; i < N_G; i++ )
	{
		FP = ALL_GRAF[i].itemLink.filePath;
		LINK_FN = ALL_GRAF[i].itemLink.name;
		var st = ALL_GRAF[i].itemLink.status;
		try
		{
			N_L_i = ALL_GRAF[i].graphicLayerOptions.graphicLayers.length;
		} catch ( error ) {};// try-catch
		// если линк потерян или не обновлен
		if( st == 1819109747 || st == 1819242340 )
		{
			if( LINKS_OK != "continue" )
			{
				LINKS_OK = false;
			};// if
		};// if
		// если линк внедрен
		if( st == LinkStatus.LINK_EMBEDDED )
		{
			N_EMBED = N_EMBED + 1;
			if( LINKS_EMB != "continue" )
			{
				LINKS_EMB = true;
			};// if
		};// if
		// сравнение текущего изображения с остальными
		for( var j = 0; j < N_G; j++ )
		{
			//  если то же самое изображение пропускаем
			if( i == j ) continue;
			//  проверяем по путям линков
			if(  FP != ALL_GRAF[j].itemLink.filePath  ) RET = false;
			// проверяем по числу слоев
			try
			{
				if( N_L_i != ALL_GRAF[j].graphicLayerOptions.graphicLayers.length ) DIF_LAY = true;
			} catch ( error ) {};// try-catch
		};// for j
	};// for i
	return RET;
};// end SAME_LINK
//
// основная подпрограмма
function main () 
{
	// вызываем проверку док-та и выделения
	if ( CHECK_SELECTION()) 
	{
		// ищем графику
		for( var i=0; i < N_sel; i++ ) FIND_GRAF ( the_sel[i] )
		N_G = ALL_GRAF.length;
		if( N_G == 0 )
		{
			the_exit("There were no images valid for the operation selected!");
		};// if
		// проверяем один ли исходный файл
		if( !SAME_LINK() )
		{
			DIF = true;
		};// if
		//  проверяем все ли выделенные линки внедрены
		if( N_EMBED == N_G )
		{
			the_exit("All selected images are ebdedded! Can not process that!");
		};// if
		//
		// составляем строку для возможных предупреждений
		var WS = "";
		if( DIF ) WS = WS + 
		"Some of selected images have different source files!\n\n";
		if( DIF_LAY ) WS = WS + 
		"Some of selected images have different layers number!\n\n";
		if( !LINKS_OK && LINKS_OK != "continue" ) WS = WS + 
		"Status of some links is not OK!\n\n";
		if( LINKS_EMB && LINKS_EMB != "continue" ) WS = WS + 
		"Some of selected images are embedded\nand will not be processed!\n\n";
		if( SOME_INV ) WS = WS + 
		"Some of selected images are invalid for the operation!\n\n";
		if(WS != "" )
		{
			WS = "Warning(s):\n\n" + WS +"Continue?";
			if( !confirm( WS ) ) the_exit("");
			LINKS_OK = "continue";
			LINKS_EMB = "continue";
		};// if
		// составляем массив слоев
		for( var i=0; i < N_G; i++ )
		{
			// если изображение не внедрено
			if( ALL_GRAF[i].itemLink.status != 1282237028 )
			{
				N_L = ALL_GRAF[i].graphicLayerOptions.graphicLayers.length;
				break;
			};// if
		};// if
		GET_PARENTS();
		// имена и видимость слоев
		for( var j = 0; j < N_L; j++)
		{
			LAYER_NAME[j] = ALL_GRAF[0].graphicLayerOptions.graphicLayers[j].name;
			LAYER_VIS_DIAL[j] = ALL_GRAF[0].graphicLayerOptions.graphicLayers[j].currentVisibility;
			ORIG_VIS[j] = ALL_GRAF[0].graphicLayerOptions.graphicLayers[j].originalVisibility;
		};// for j
		// состояние слоев документа
		for( var i = 0; i < AD.layers.length; i++ )
		{
			LL[i] = AD.layers[i].locked;
			LV[i] = AD.layers[i].visible;
		};// for i
		// если в порядке выделение и док-т:
		// устанавливаем начальные значения параметров для диалога
		//создаем диалог
		dlg = new Window('dialog');
		// определяем файловую систему
		if(File.fs == "Windows") WFS = true;
		dlg.text = the_title + " v." +the_version; // заголовок диалога
		dlg.alignChildren = 'center';
		//
		var OPT_GR = dlg.add('group');
		OPT_GR.alignChildren = 'left';
		OPT_GR.orientation = 'column';
		//
		if( !DIF )
		{
			var LINK_FN_TEXT = OPT_GR.add('statictext');
			LINK_FN_TEXT.text = "Source link name: "+SHORT_NAME(LINK_FN, 15);
			try
			{
				var f = new File(FP)
				f = f.fsName;
			} catch ( error ){};
			var LINK_P_TEXT = OPT_GR.add('statictext');
			LINK_P_TEXT.text = "Source link full path: "
			var LINK_PN_TEXT = OPT_GR.add('edittext', undefined, "", {multiline: true, readonly: true} );
			LINK_PN_TEXT.text = unescape( f );
			LINK_PN_TEXT.minimumSize.width = LINK_PN_TEXT.maximumSize.width = 270;
			LINK_PN_TEXT.maximumSize.height = 80;
		};// if
		//
		var N_LAY_TXT = OPT_GR.add('statictext');
		N_LAY_TXT.text = "Source image layers number: "+N_L;
		//
		var N_G_TEXT = OPT_GR.add('statictext');
		var the_name = ALL_GRAF[0].constructor.name;
		N_G_TEXT.text = "Images selected: "+N_G;
		//
		WHAT_PROC = OPT_GR.add('group');
		WHAT_PROC.orientation = 'row';
		var WHAT_PROC_TXT = WHAT_PROC.add('statictext');
		WHAT_PROC_TXT .text = "Process range:";
		var WHAT_DROP = WHAT_PROC.add('dropdownlist');
		var WHAT_DROP_LEN = 165; if( WFS ) WHAT_DROP_LEN = 176;
		WHAT_DROP.minimumSize.width =
		WHAT_DROP.maximumSize.width = WHAT_DROP_LEN;
		var WHAT_ARR = new Array();
		if( !DIF )
		{
			WHAT_ARR[0] = "Selected instances";
			if( N_G == 1 ) WHAT_ARR[0] = "Selected instance";
			WHAT_ARR[1] = "All instances on active spread";
			WHAT_ARR[2] = "All instances in the document";
		}
		else
		{
			WHAT_ARR[0] = "Selected images";
		};// if
		for( var i=0; i < WHAT_ARR.length; i++ )
		{
			WHAT_DROP.add('item', WHAT_ARR[i]);
		};// for i
		WHAT_DROP.selection = 0;
		//
		// подпрограмма создания строки для вывода параметров слоя
		function LAYER_STR(N, where)
		{
			var the_str = where.add('group');
			the_str.orientation = 'row';
			the_str.alignChildren = 'left';
			var the_num = the_str .add('statictext');
			the_num.characters = 3;
			the_num.text = N_L - N+"";
			var the_name = the_str .add('statictext');
			var N_CH = 15; if( WFS ) N_CH = 21;
			the_name.characters = N_CH;
			the_name.text = LAYER_NAME[ N ];
			var the_stat = the_str .add('checkbox');
			the_stat.value = LAYER_VIS_DIAL[ N ];
			the_stat.onClick  = function REFRESH_CB()
			{
				var k = 0;
				for( var i = N_TOP; i >= N_BOT; i-- )
				{
					LAYER_VIS_DIAL[N_L-i] = DIAL_STAT_DISPLAY[k][2].value;
					k = k + 1;
				};// for i
				return;
			};// end REFRESH_CB
			var orig_stat = the_str .add('checkbox');
			orig_stat.value = ORIG_VIS[ N ];
			orig_stat.enabled = false;
			//                    0                  1                  2                3
			return [the_num, the_name,  the_stat, orig_stat];
		};// end LAYER_INFO
		//
		// подпрограмма создания кнопки
		function BUTTON(where, text)
		{
			var b = where.add('button');
			b.text = text;
			return b;		
		};// end BUTTON
		// создаем панель в которой будет информация о слоях
		var mp = dlg.add('panel');
		// максимальное количество строк для вывода слоев
		var MAX_LAYER = 10;
		var NO_BUTTONS = false;
		//
		// если число слоев меньше или равно максимальному
		if( N_L <= MAX_LAYER ) 
		{
			NO_BUTTONS = true;
			for( var i = 0; i < N_L ; i++ ) 
			{
				var ARR = new Array();
				ARR = LAYER_STR(i, mp);
				DIAL_STAT_DISPLAY[i] = new Array(ARR[0], ARR[1], ARR[2], ARR[3]);
			};// for
		}
		else
		{
			// если число слоев больше максимального
			NO_BUTTONS = false;
			var TOP_G = mp.add('group');
			//
			// подпрограмма создания линиии в диалоге
			function MAKE_LINE() 
			{
				var the_line = mp.add('panel');
				the_line.bounds = [0, undefined, 230, undefined];
				return;
			};// end MAKE_LINE
			//
			TOP_G.orientation = 'row';
			var TOP = BUTTON(TOP_G, "Top");
			TOP.onClick = function () { TOP_CLICK = true; REFRESH() };
			var UP = BUTTON(TOP_G, "Up");
			UP.onClick = function () { UP_CLICK = true; REFRESH() };
			MAKE_LINE();
			var N_TOP = N_L;
			var N_BOT = N_L - (MAX_LAYER - 1);
			var k = 0;
			for( var i = N_TOP; i >= N_BOT; i-- )  
			{
				var ARR = new Array();
				ARR = LAYER_STR(k, mp);
				DIAL_STAT_DISPLAY[k] = new Array(ARR[0], ARR[1], ARR[2], ARR[3]);
				k = k + 1;
			};// for
			var TOP_CLICK = false;
			var BOTTOM_CLICK = false;
			var UP_CLICK = false;
			var DOWN_CLICK = false;
			TOP.enabled = UP.enabled = false;
			//
			function REFRESH()
			{
				// подпрограмма обнуления кликов
				function ALL_FALSE()
				{
					TOP_CLICK = BOTTOM_CLICK = UP_CLICK = DOWN_CLICK = false;
					return;
				};// end ALL_FALSE
				// в самый верх
				if( TOP_CLICK )
				{
					if( N_TOP == N_L ) { ALL_FALSE(); return };
					N_TOP = N_L;
					N_BOT = N_L - (MAX_LAYER - 1);
					TOP.enabled = UP.enabled = false;
					BOTTOM.enabled = DOWN.enabled = true;
				};// if
				// в самый низ
				if( BOTTOM_CLICK )
				{
					if( N_BOT == 1 ) { ALL_FALSE(); return };
					N_TOP = MAX_LAYER;
					N_BOT = 1;
					TOP.enabled = UP.enabled = true;
					BOTTOM.enabled = DOWN.enabled = false;
				};// if
				// на 1 слой вверх
				if( UP_CLICK )
				{
					if( N_TOP == N_L ) 
					{ 
						TOP.enabled = UP.enabled = false;
						ALL_FALSE(); 
						return;
					};// if
					N_TOP = N_TOP + 1;
					N_BOT = N_BOT + 1;
					if( N_TOP == N_L ) TOP.enabled = UP.enabled = false;
					BOTTOM.enabled = DOWN.enabled = true;
				};// if
				// на 1 слой вниз
				if( DOWN_CLICK )
				{
					if( N_BOT == 1 ) 
					{ 
						BOTTOM.enabled = DOWN.enabled = false;
						ALL_FALSE(); 
						return;
					};// if
					N_TOP = N_TOP - 1;
					N_BOT = N_BOT - 1;
					if( N_BOT == 1 ) BOTTOM.enabled = DOWN.enabled = false;
					TOP.enabled = UP.enabled = true;
				};// if
				var k = 0;
				for( var i = N_TOP; i >= N_BOT; i-- )
				{
					DIAL_STAT_DISPLAY[k][0].text = N_TOP - k + "";
					var N_L_MINUS_I = N_L - i;
					DIAL_STAT_DISPLAY[k][1].text = LAYER_NAME[ N_L_MINUS_I ];
					DIAL_STAT_DISPLAY[k][2].value = LAYER_VIS_DIAL[ N_L_MINUS_I ];
					DIAL_STAT_DISPLAY[k][3].value = ORIG_VIS[ N_L_MINUS_I ];
					k = k+1;
				};// for i
				ALL_FALSE();
				return;
			};// end REFRESH
			//
			MAKE_LINE();
			var BOTTOM_G = mp.add('group');
			BOTTOM_G.orientation = 'row';
			var BOTTOM = BUTTON(BOTTOM_G, "Bottom");
			BOTTOM.onClick = function () { BOTTOM_CLICK = true; REFRESH() };
			var DOWN = BUTTON(BOTTOM_G, "Down");
			DOWN.onClick = function () { DOWN_CLICK = true; REFRESH() };
		};// if-else
		// 
		// создание панели кнопок (кнопка ОК, кнопка Cancel)
		var OK_PAN = dlg.add('group');
		OK_PAN.orientation = 'row';
		var okBtn = OK_PAN.add('button', undefined, 'OK');// кнопка ОК
		var cancelBtn = OK_PAN.add('button',undefined, 'Cancel');// кнопка Cancel
		//
		// собственно показываем окно диалога
		var DIALOG_BUTTON = dlg.show();
		// если выбрана первая кнопка (ОК) выполняем
		if (DIALOG_BUTTON == 1) 
		{
			if( NO_BUTTONS )
			{
				for( var i = 0; i < N_L; i++ ) 
				{
					DIAL_STAT[i] = DIAL_STAT_DISPLAY[i][2].value;
				};// for
			}
			else
			{
				DIAL_STAT = LAYER_VIS_DIAL;
			};// if-else
			WHAT_PROC = WHAT_DROP.selection.index;
			// выполнение
			SET();
			REPORT();
		};// if DIALOG_BUTTON == 1
	};// if CHECK_SELECTION()
	// завершение работы штатное (выход)
	the_exit("");
	return;
};//end main()
//
// продпрограмма выполнения скрипта (в диалоге был ОК)
function SET() 
{
	function GET_ISTANCES( s )
	{
		var RANGE = "";
		if( WHAT_PROC == 1 ) RANGE = " on active spread";
		if( WHAT_PROC == 2 ) RANGE = " in active document";
		var LINKS_NOT_OK = false;
		var LINKS_NOT_EMB = true;
		for( var i=0; i < s.allGraphics.length; i++ )
		{
			var AG = s.allGraphics[i];
			// проверяем на копи-пейст изображение
			try
			{
				var FP_i = AG.itemLink.filePath;
				if( FP_i == null ) continue;
			}
			catch ( error )
			{
				continue;
			};// try-catch
			if( FP_i == FP )
			{
				ALL_GRAF.push(AG);
				var st = parseInt(AG.itemLink.status);
				// если линк потерян или не обновлен
				if( (st == 1819109747) || (st == 1819242340) )
				{
					LINKS_NOT_OK = true;
				};// if
				// если линк внедрен
				if( st == 1282237028 && LINKS_EMB != "continue" )
				{
					LINKS_NOT_EMB = false;
				};// if
			};// if
		};// for
		//
		// выводим предупреждения если они есть
		var WS = "";
		if( LINKS_NOT_OK ) WS = WS +
		"Some of instances of\n"+
		 SHORT_NAME(ALL_GRAF[0].itemLink.name, 25)+"\n"+
		RANGE+" have non OK link status!\n\n";
		if( !LINKS_NOT_EMB ) WS = WS +
		"Some of instances of\n"+
		 SHORT_NAME(ALL_GRAF[0].itemLink.name, 25)+"\n"+
		RANGE+" are embedded and will not be processed!\n\n";
		if( WS != "" )
		{
			WS = "Warning(s):\n\n" + WS +"Continue?";
			if( !confirm( WS ) ) the_exit("");
			if( LINKS_NOT_OK ) LINKS_OK = "continue";
			if( !LINKS_NOT_EMB ) LINKS_EMB = "continue";
		};// if
		return;
	};// end GET_ISTANCES
	//
	// если диапазон на активном развороте
	if( WHAT_PROC == 1 ) 
	{
		ALL_GRAF = new Array();
		GET_ISTANCES( app.activeWindow.activeSpread )
	};// if
	// если диапазон во всем документе
	if( WHAT_PROC == 2 ) 
	{
		ALL_GRAF = new Array();
		for( var i=0; i < AD.spreads.length; i++ ) GET_ISTANCES( AD.spreads[i] );
		for( var i=0; i < AD.masterSpreads.length; i++ ) GET_ISTANCES( AD.masterSpreads[i] );
	};// if
	// обновляем число изображений
	N_G = ALL_GRAF.length;
	// получаем родителей
	GET_PARENTS();
	// изображения
	for( var i=0; i < N_G; i++ )
	{
		var AG_i = ALL_GRAF[i];
		var AG_P_i = ALL_GRAF_PAR[i];
		var AG_index_i = ALL_GRAF_INDEX[i];
		// если изображение внедрено пропускаем
		N_OK = N_OK +1;
		if( AG_i.itemLink.status == 1282237028 )
		{
			N_EMB_SKIP = N_EMB_SKIP + 1;
			N_OK = N_OK - 1;
			continue;
		};// if
		try
		{
			var the_layer = AG_P_i.itemLayer;
			// открываем слой если он был заблокирован
			if( the_layer.locked ) 
			{
				the_layer.locked = false;
				LAYER_WAS_OPEN = true;
			};// if
			// открываем слой если он был невидимый
			if( !the_layer.visible ) 
			{
				the_layer.visible = true;
				LAYER_WAS_OPEN = true;
			};// if
		} catch ( error ) {};
		// слои
		for( var j = 0; j < N_L; j++)
		{
			try
			{
				if( AG_i.constructor.name == "PDF" )
				{
					var L = AG_P_i.pdfs[AG_index_i].graphicLayerOptions.graphicLayers[j];
				};// if
				if( AG_i.constructor.name == "Image" )
				{
					var L = AG_P_i.images[AG_index_i].graphicLayerOptions.graphicLayers[j];
				};// if
				if( AG_i.constructor.name == "ImportedPage" )
				{
					var L = AG_P_i.importedPages[AG_index_i].graphicLayerOptions.graphicLayers[j];
				};// if
				var V = L.currentVisibility;
				if( V != DIAL_STAT[j] ) L.currentVisibility = DIAL_STAT[j];
			} 
			catch ( error ) 
			{
				N_ER = N_ER +1;
			};// try-catch
		};// for j
	};// for i
	if( LAYER_WAS_OPEN )
	{
		for( var i=0; i < AD.layers.length; i++ )
		{
			AD.layers[i].visible = LV[i];
			AD.layers[i].locked = LL[i];
		};// for i
	};// if
	return;
};// end ADDING()
//
// подпрограмма проверки выделения
function CHECK_SELECTION() 
{
	// есть ли открытые документы
	N_doc = app.documents.length;
	if (N_doc < 1 ) 
	{
		alert( "There are no open documents!");
		return false;
	};// if
	AD = app.activeDocument;
	AL = AD.activeLayer;
	SEL_LAYER = AL;
	AP = app.activeWindow.activePage
	AS = app.activeWindow.activeSpread;
	the_sel = AD.selection;
	N_sel = the_sel.length;
	if( N_sel == 0 )
	{
		alert( "No images were selected!");
		return false;
	};// if
	SELECTION_DIM();
	return true;
};// end CHECK_SELECTION
//
// подпрограмма вычисления размеров выделения
function SELECTION_DIM() 
{
	// для каждого объекта в выделении
	for(var i=0; i < N_sel; i++) 
	{
		var b_arr = new Array();
		try 
		{
			// получаем общие границы выделенного объекта
			b_arr = SEL_OBJ_BOUNDS ( the_sel[i] );
		} 
		catch ( error ) 
		{
			the_exit("Can not process the selection!");
		};// try-catch
	};// for i
	return;
};// end SELECTION_DIM
//
// подпрограмма получения границ по выделению
function SEL_OBJ_BOUNDS ( the_obj ) 
{
	// left
	var g_L =  the_obj.geometricBounds[1];
	var v_L =  the_obj.visibleBounds[1];
	// top
	var g_T =  the_obj.geometricBounds[0];
	var v_T =  the_obj.visibleBounds[0];
	// right
	var g_R =  the_obj.geometricBounds[3];
	var v_R =  the_obj.visibleBounds[3];
	// bottom
	var g_B =  the_obj.geometricBounds[2];
	var v_B =  the_obj.visibleBounds[2];
	return [g_L, g_T, g_R, g_B,   v_L, v_T, v_R, v_B];
};// end SEL_OBJ_BOUNDS
//
// подпрограмма окончания скрипта
function the_exit(txt)
{
	if( txt !="") alert(txt);
	exit();
};// end the_exit
//
// подпрограмма вывода результатов
function REPORT()
{
	var S = "Images processed: "+N_OK+"\n";
	if( N_EMB_SKIP > 0 ) S = S + "Embedded images skipped: "+N_EMB_SKIP+"\n";
	if( N_ER > 0 ) S = S + "Process errors: "+N_ER+"\n";
	alert( "Report:\n" + S );
	return;
};// end REPORT
//
// подпрограмма формирования массива родителей
function GET_PARENTS()
{
	for( var i=0; i< N_G; i++)
	{
		ALL_GRAF_PAR[i] = ALL_GRAF[i].parent;
		ALL_GRAF_INDEX[i] = ALL_GRAF[i].index;
	};// for i
	return;
};// end GET_PARENTS
//
// подпрограмма сокращения длины файла
function SHORT_NAME(txt, N) 
{
	if ( txt.length > N ) txt = txt.substr(0, N) + "...";
	return txt;
};// end SHORT_NAME
